CC = gcc
CFLAGS = -Wall -O0 -fno-plt -fcf-protection=none -fno-stack-protector

default: libctest.so prog main

foo.o: foo.c foo.h
	$(CC) -c -fPIC $(CFLAGS) -o foo.o foo.c

ctest.o: ctest.c ctest.h
	$(CC) -c -fPIC $(CFLAGS) -o ctest.o ctest.c

libfoo.so: foo.o
	$(CC) -shared -Wl,-soname,libfoo.so -fPIC $(CFLAGS) foo.o -o libfoo.so

libctest.so: ctest.o libfoo.so
	$(CC) -shared -Wl,-soname,libctest.so -fPIC $(CFLAGS) ctest.o -o libctest.so -L. -lfoo

prog: prog.c libctest.so
	$(CC) $(CFLAGS) -o prog prog.c -L. -lctest

main: main.c libfoo.so
	$(CC) $(CFLAGS) -o main main.c -L. -lfoo

clean:
	rm -rf main prog libctest.so libfoo.o *.o

test:
	./prog
	./main
